<template>
  <q-date
    v-model="selectedDates"
    multiple
    :title="title"
    subtitle="點選切換、自動儲存"
    @update:model-value="handleUpdate"
  />
</template>

<script lang='ts' setup>
import { computed, defineComponent, PropType, ref } from 'vue';
import { StaffMember, StaffMemberHoliday } from '../types/main.type';

import { useMainStore } from '../store/main.store';

type UpdateReason =
  | 'mask'
  | 'locale'
  | 'add-day'
  | 'remove-day'
  | 'add-range'
  | 'remove-range'
  | 'year'
  | 'month';

interface UpdateDetails {
  year: number;
  month: number;
  day: number;
  from: {
    year: number;
    month: number;
    day: number;
  };
  to: {
    year: number;
    month: number;
    day: number;
  };
}

interface Props {
  member: StaffMember;
}
const props = withDefaults(defineProps<Props>(), {});

const store = useMainStore();

const selectedDates = ref<string[]>([]);

const loadDates = () => {
  const days: string[] = store.holidays
    .filter(
      (day: StaffMemberHoliday) => day.member.name === props.member.name
    )
    .map((day: StaffMemberHoliday) => day.date);

  selectedDates.value = [...new Set(days)];
};
loadDates();

const handleUpdate = (
  value: any,
  reason: UpdateReason,
  { year, month, day }: UpdateDetails
) => {
  const yyyy = year.toString().padStart(4, '0');
  const mm = month.toString().padStart(2, '0');
  const dd = day.toString().padStart(2, '0');

  const date = `${yyyy}/${mm}/${dd}`;
  // console.log(`[ handleUpdate ] date : `, date);

  const holiday: StaffMemberHoliday = {
    date,
    member: props.member,
  };

  if (reason === 'add-day') {
    store.addHoliday(holiday);
  }

  if (reason === 'remove-day') {
    store.removeHoliday(holiday);
  }
};

const title = computed(() => {
  return `選擇${props.member.name}約假日`;
});
</script>

<style scoped lang='sass'>

</style>
